Home | All Classes | Main Classes | Annotated | Grouped Classes |

# QThread Class Reference

The QThread class provides platform-independent threads. More...

`#include <qthread.h>`

Inherits Qt.

List of all member functions.

## Public Members

- QThread ()
- virtual ~QThread ()
- bool wait ( unsigned long time = ULONG_MAX )
- void start ()
- bool finished () const
- bool running () const

## Static Public Members

- Qt::HANDLE currentThread ()
- void postEvent ( QObject * receiver, QEvent * event )
- void exit ()

## Protected Members

- virtual void run () = 0

## Static Protected Members

- void sleep ( unsigned long secs )
- void msleep ( unsigned long msecs )
- void usleep ( unsigned long usecs )

## Detailed Description

The QThread class provides platform-independent threads.

A QThread represents a separate thread of control within the program; it shares data with all the other threads within the process but executes independently in the way that a separate program does on a multitasking operating system. Instead of starting in main(), QThreads begin executing in run(). You inherit run() to include your code. For example:

        class MyThread : public QThread {

        public:

            virtual void run();

        };

        void MyThread::run()
        {
            for( int count = 0; count < 20; count++ ) {
                sleep( 1 );
                qDebug( "Ping!" );
            }
        }

        int main()
        {
            MyThread a;
            MyThread b;
            a.start();
            b.start();
            a.wait();
            b.wait();
        }

This will start two threads, each of which writes Ping! 20 times to the screen and exits. The wait() calls at the end of main() are necessary because exiting main() ends the program, unceremoniously killing all other threads. Each MyThread stops executing when it reaches the end of MyThread::run(), just as an application does when it leaves main().

See also Thread Support in Qt, Environment Classes and Threading.

## Member Function Documentation

### QThread::QThread ()

Constructs a new thread. The thread does not begin executing until start() is called.

### QThread::~QThread ()`[virtual]`

QThread destructor.

Note that deleting a QThread object will not stop the execution of the thread it represents. Deleting a running QThread (i.e. finished() returns FALSE) will probably result in a program crash. You can wait() on a thread to make sure that it has finished.

### Qt::HANDLE QThread::currentThread ()`[static]`

This returns the thread handle of the currently executing thread.

Warning: The handle returned by this function is used for internal purposes and should not be used in any application code. On Windows, the returned value is a pseudo handle for the current thread, and it cannot be used for numerical comparison.

### void QThread::exit ()`[static]`

Ends the execution of the calling thread and wakes up any threads waiting for its termination.

### bool QThread::finished () const

Returns TRUE is the thread is finished; otherwise returns FALSE.

### void QThread::msleep ( unsigned long msecs )`[static protected]`

System independent sleep. This causes the current thread to sleep for msecs milliseconds

### void QThread::postEvent ( QObject * receiver, QEvent * event )`[static]`

Provides a way of posting an event from a thread which is not the event thread to an object.

This is achieved as follows:

- The event is put into a queue;
- the event thread is woken up;
- the event thread sends the event to the receiver object.

It is important to note that the event handler for the event, when called, will be called from the event thread and not from the thread calling QThread::postEvent().

Since QThread::postEvent() posts events into the event queue of QApplication, you must create a QApplication object before calling QThread::postEvent().

The event must be allocated on the heap since the post event queue will take ownership of the event and delete it once it has been posted.

See also QApplication::postEvent().

### void QThread::run ()`[pure virtual protected]`

This method is pure virtual, and must be implemented in derived classes in order to do useful work. Returning from this method will end the execution of the thread.

See also wait().

### bool QThread::running () const

Returns TRUE if the thread is running; otherwise returns FALSE.

### void QThread::sleep ( unsigned long secs )`[static protected]`

System independent sleep. This causes the current thread to sleep for secs seconds.

### void QThread::start ()

This begins the execution of the thread by calling run(), which should be reimplemented in a QThread subclass to contain your code. If you try to start a thread that is already running, this call will wait until the thread has finished, and then restart the thread.

### void QThread::usleep ( unsigned long usecs )`[static protected]`

System independent sleep. This causes the current thread to sleep for usecs microseconds

### bool QThread::wait ( unsigned long time = ULONG_MAX )

This provides similar functionality to POSIX pthread_join. A thread calling this will block until either of these conditions is met:

- The thread associated with this QThread object has finished execution (i.e. when it returns from run()). This function will return TRUE if the thread has finished. It also returns TRUE if the thread has not been started yet.
- time milliseconds has elapsed. If time is ULONG_MAX (the default), then the wait will never timeout (the thread must return from run()). This function will return FALSE if the wait timed out.

This file is part of the Qt toolkit. Copyright © 1995-2002 Trolltech. All Rights Reserved.